// DocVars.h: interface for the CDocVars class.
// As part of the Undo_Redo_Demo application
// By Tom Morris of trilobiteWorks. December 2002
// Use freely...

#pragma once

//	we derive from CObject mainly so we can simplify serialization
class  CDocVars  : public CObject
{
	DECLARE_SERIAL (CDocVars)
public:
CDocVars();

	//	variables we wish to use in our document
	//	Let's have an array of CPoints -- to demonstrate collections
	//	and let's put in a CString to demonstrate how to handle 
	//	single instance variables per DocVars

	CArray<CPoint, CPoint&> dv_arrayPoints;
	CString					dv_strLabel;

	//	Since this class is derived from CObject, we have to prepare
	//	a Copy Constructor and methods for doing simple comparison
	//	operations (assignment operators). This class has only a single
	//	assignment operator for ( = ). If you need others, you will need
	//	to prepare them. 

	//	copy constructor
	CDocVars(const CDocVars &s)	
	{
		dv_arrayPoints.RemoveAll();
		INT_PTR	iNumPoints = s.dv_arrayPoints.GetCount();
		for (INT_PTR i = 0; i < iNumPoints; i++)
		{
			CPoint tempPoint = s.dv_arrayPoints.GetAt(i);
			dv_arrayPoints.Add(tempPoint);
		}

		dv_strLabel = s.dv_strLabel;
	}

	//	assignment operator
	CDocVars& operator=(const CDocVars &s)	
	{
		dv_arrayPoints.RemoveAll();
		INT_PTR	iNumPoints = s.dv_arrayPoints.GetCount();
		for (INT_PTR i = 0; i < iNumPoints; i++)
		{
			CPoint tempPoint = s.dv_arrayPoints.GetAt(i);
			dv_arrayPoints.Add(tempPoint);
		}
	
		dv_strLabel = s.dv_strLabel;

		return *this;
	}

	void	Serialize(CArchive &ar);

	virtual ~CDocVars();

};

