// Undo_Redo_DemoView.cpp : implementation of the CUndo_Redo_DemoView class
// As part of the Undo_Redo_Demo application
// By Tom Morris of trilobiteWorks. December 2002
// Use freely...

#include "stdafx.h"
#include "Undo_Redo_Demo.h"
#include "Undo_Redo_DemoDoc.h"
#include "Undo_Redo_DemoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CUndo_Redo_DemoView

IMPLEMENT_DYNCREATE(CUndo_Redo_DemoView, CView)

BEGIN_MESSAGE_MAP(CUndo_Redo_DemoView, CView)
	ON_WM_LBUTTONUP()
END_MESSAGE_MAP()

// CUndo_Redo_DemoView construction/destruction

CUndo_Redo_DemoView::CUndo_Redo_DemoView()
{
	// TODO: add construction code here

}

CUndo_Redo_DemoView::~CUndo_Redo_DemoView()
{
}


/////////////////////////////////////////////////////////////////////////////
//	PreCreateWindow
//	
/////////////////////////////////////////////////////////////////////////////
BOOL CUndo_Redo_DemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CUndo_Redo_DemoView drawing
/////////////////////////////////////////////////////////////////////////////
//	OnDraw
//	
/////////////////////////////////////////////////////////////////////////////
void CUndo_Redo_DemoView::OnDraw(CDC* /*pDC*/)
{
	//	Note that this function gets its critical parameters from
	//	the document's current DocVars

	CUndo_Redo_DemoDoc* pDoc = NULL;
	pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if (pDoc)
	{
		//	since all we need is information about DocVars parameters,
		//	we just get a pointer to them.
		CDocVars	*pDocVars = NULL;
		pDocVars = pDoc->DocVarsGetPointer();
		if (pDocVars)
		{
			INT_PTR iNumPoints = pDocVars->dv_arrayPoints.GetCount();
			for (INT_PTR i = 0; i < iNumPoints; i++)
			{
				CPoint	tempPoint(0,0);
				tempPoint = pDocVars->dv_arrayPoints.GetAt(i);
				DrawX(&tempPoint);

				//	print the label for the most recent point
				if (i == (iNumPoints -1))
				{
					DrawLabel(&pDocVars->dv_strLabel, &tempPoint);
				}
			}
		}
	}
	// TODO: add draw code for native data here
}


// CUndo_Redo_DemoView diagnostics

#ifdef _DEBUG
/////////////////////////////////////////////////////////////////////////////
//	AssertValid
//	
/////////////////////////////////////////////////////////////////////////////
void CUndo_Redo_DemoView::AssertValid() const
{
	CView::AssertValid();
}


/////////////////////////////////////////////////////////////////////////////
//	Dump
//	
/////////////////////////////////////////////////////////////////////////////
void CUndo_Redo_DemoView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}


/////////////////////////////////////////////////////////////////////////////
//	GetDocument
//	
/////////////////////////////////////////////////////////////////////////////
CUndo_Redo_DemoDoc* CUndo_Redo_DemoView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CUndo_Redo_DemoDoc)));
	return (CUndo_Redo_DemoDoc*)m_pDocument;
}
#endif //_DEBUG


// CUndo_Redo_DemoView message handlers


/////////////////////////////////////////////////////////////////////////////
//	DrawX
//	
/////////////////////////////////////////////////////////////////////////////
void	CUndo_Redo_DemoView::DrawX(CPoint *pPoint)
{
	CClientDC	dc(this);

	CPen	tempPen(PS_SOLID, 16, RGB(255,0,0));
	CPen	*pOldPen = NULL;
	pOldPen = dc.SelectObject(&tempPen);
	CRect tempRect;
	tempRect.bottom = pPoint->y + 20;
	tempRect.top = pPoint->y - 20;
	tempRect.left = pPoint->x - 20;
	tempRect.right = pPoint->x + 20;

	dc.MoveTo(tempRect.left, tempRect.top);
	dc.LineTo(tempRect.right, tempRect.bottom);
	dc.MoveTo(tempRect.left, tempRect.bottom);
	dc.LineTo(tempRect.right, tempRect.top);
	dc.SelectObject(pOldPen);
}


/////////////////////////////////////////////////////////////////////////////
//	DrawLabel
//	
/////////////////////////////////////////////////////////////////////////////
void	CUndo_Redo_DemoView::DrawLabel(CString	*pstrLabel, CPoint *pPoint)
{
	CClientDC	dc(this);
	CRect	tempRect;
	tempRect.top = pPoint->y + 30;
	tempRect.bottom = pPoint->y + 70;
	tempRect.left = pPoint->x - 60;
	tempRect.right = pPoint->x + 60;

	CPen	tempPen(PS_SOLID, 4, RGB(0,0,0));
	CPen	*pOldPen = NULL;
	pOldPen = dc.SelectObject(&tempPen);
	dc.DrawText(*pstrLabel, &tempRect, DT_CENTER | DT_BOTTOM);
	dc.SelectObject(pOldPen);
}


/////////////////////////////////////////////////////////////////////////////
//	OnLButtonUp
//	
/////////////////////////////////////////////////////////////////////////////
void CUndo_Redo_DemoView::OnLButtonUp(UINT nFlags, CPoint point)
{
	//	This is an example of how to modify document variables
	//	using the DocVars technique.

	//	we are going to get the CPoint information from the mouse
	//	and add this information to our document's list of points.
	//	We will also modify the DocVar's single string variable so
	//	that it reflects the latest CPoint information.

	//	The document maintains a list of points through its current
	//	DocVars member. But we won't modify the current DocVars directly.

	CUndo_Redo_DemoDoc	*pDoc = NULL;
	pDoc = GetDocument();
	if (pDoc)
	{
		CString	strX, strY;
		
		char *pcharX = strX.GetBuffer(16);
		char *pcharY = strY.GetBuffer(16);;
		itoa(point.x, pcharX, 10);
		itoa(point.y, pcharY, 10);
		strX = pcharX;
		strY = pcharY;

		//	Here, we get a copy of the document's current DocVars -- by value,
		//	NOT a pointer. We modify variables in the COPY, then send the modified
		//	version to the document's update manager. The update manager
		//	adds the modified DocVars to the list and returns a copy of it
		//	to the document where it becomes the document's current DocVars.
		CDocVars	thisFunctionDocVars;
		thisFunctionDocVars = pDoc->DocVarsGetByValue();
		thisFunctionDocVars.dv_arrayPoints.Add(point);
		thisFunctionDocVars.dv_strLabel = strX + _T(" x ") + strY;

		//	Update the Document	**********************
		pDoc->DocVarsUpdate(thisFunctionDocVars);
		//	******************************************
	}
	
	// TODO: Add your message handler code here and/or call default

	CView::OnLButtonUp(nFlags, point);
}
